/*
 * Mintaprogramok/9. fejezet
 * KepAtmeretezess.java
 *
 * Angster Erzsbet: OO tervezs s programozs, Java II. ktet
 * 2002.09.01.
 */

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

class Kep extends JPanel {                                 //1
  private Image img;              // eredeti kp
  private Image fittedImg = null; // kicsinytett/nagytott kp
  private double ratio;           // arny: szlessg/magassg
  private String fileName;        // a kpllomny neve
  private MediaTracker tr;

  public Kep(String fileName) {
    // A kp betltse file-bl a mdiakvet segtsgvel:
    this.fileName = fileName;
    img = Toolkit.getDefaultToolkit().createImage(fileName);//2
    tr = new MediaTracker(this);
    tr.addImage(img,0);
    try {
      tr.waitForID(0);
    }
    catch (InterruptedException ex) {
    }
    finally {
      tr.removeImage(img,0);
    }

    // Arny (ratio) szmtsa. Csak akkor j, ha betltdtt a kp:
    ratio = 1.0*img.getWidth(this)/img.getHeight(this);
    System.out.println("ratio= " + ratio);

    addComponentListener(new ComponentAdapter() {          //3
      // tmreteztk a panelt:
      public void componentResized(ComponentEvent e) {
        // A kp tmretezse a mediakvet segtsgvel.
        // Igazts a komponens szlessghez vagy magassghoz:
        if (getHeight()*ratio>getWidth())                  //4
          // A kp szlessge a komponens szlessge lesz:
          fittedImg = img.getScaledInstance(getWidth(),-1,Image.SCALE_DEFAULT);
        else
          // A kp magassga a komponens magassga lesz:
          fittedImg = img.getScaledInstance(-1,getHeight(),Image.SCALE_DEFAULT);

        tr = new MediaTracker(e.getComponent());           //5
        tr.addImage(fittedImg,0);
        try {
          tr.waitForID(0);
        }
        catch (InterruptedException ex) {
        }
        finally {
          tr.removeImage(img,0);
        }
      }
    });
  }

  protected void paintComponent(Graphics gr) {             //6
    super.paintComponent(gr);
    // A kp kirajzolsa:
    gr.drawImage(fittedImg,0,0,this);

    // A kpfjl nevnek megjelentse egy szrke tglalapban:
    gr.setColor(Color.LIGHT_GRAY);
    gr.fillRoundRect(0,getHeight()-30,300,30,5,5);
    gr.setColor(Color.BLACK);
    gr.drawRoundRect(0,getHeight()-30,300,30,5,5);
    gr.setFont(new Font("TimesRoman",Font.PLAIN,20));
    gr.drawString(fileName,10,getHeight()-10);
  }
}

public class KepAtmeretezes extends JFrame {

  public KepAtmeretezes() {                                   //7
    Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();
    setBounds(0,0,dim.width,dim.height-50);
    setDefaultCloseOperation(EXIT_ON_CLOSE);
    getContentPane().add(new Kep("images/SanFran.jpg"));
    //getContentPane().add(new Kep("images/auto.jpg"));
    //getContentPane().add(new Kep("images/PosterChild.jpg"));
    show();
  }

  public static void main (String args[]) {
    new KepAtmeretezes();
  }
}
