/*
 * Mintaprogramok/10. fejezet
 * Rajzolas.java
 *
 * Angster Erzsbet: OO tervezs s programozs, Java II. ktet
 * 2002.09.01.
 */

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Vector;

class Rajzlap extends JPanel implements MouseListener,
                                MouseMotionListener {
  // Minden eleme egy egyszn, sszefgg vonal:
  private Vector vonalak = new Vector();
  private Polygon aktVonal;

  // A szneket kln vektorban troljuk:
  private Vector vonalSzinek = new Vector();
  private Color aktSzin;

  public Rajzlap() {
    setSize(400,400);
    addMouseListener(this);
    addMouseMotionListener(this);
  }

  // A kp trlse:
  public void clear() {
    vonalak.clear();
    vonalSzinek.clear();
    repaint();
  }

  // Aktulis rajzolszn belltsa:
  public void setColor(Color c) {
    aktSzin = c;
  }

  // A teljes kp (sszes sokszg) kirajzolsa:
  public void paintComponent(Graphics gr) {
    super.paintComponent(gr);
    Polygon vonal;
    Color szin;
    for (int i=0; i<vonalak.size(); i++) {
      szin = (Color)(vonalSzinek.get(i));
      vonal = (Polygon)(vonalak.get(i));
      gr.setColor(szin);
      gr.drawPolyline(vonal.xpoints,vonal.ypoints,vonal.npoints);
    }
  }

  public void mouseClicked(MouseEvent e) {
  }

  public void mousePressed(MouseEvent e) {
    // Vonalkezds, egy pont hozzadsa a sokszghz.
    // Elszr adatmdosts:
    int x=e.getX(), y=e.getY();
    vonalSzinek.add(aktSzin);
    vonalak.add(aktVonal = new Polygon());
    aktVonal.addPoint(x,y);
    // Pont kirajzolsa:
    Graphics gr = getGraphics();
    gr.setColor(aktSzin);
    gr.drawLine(x,y,x,y);
    gr.dispose();
  }

  public void mouseReleased(MouseEvent e) {
  }

  public void mouseEntered(MouseEvent e) {
  }

  public void mouseExited(MouseEvent e) {
  }

  public void mouseDragged(MouseEvent e) {
    // Vonal folytatsa, ha mr el van kezdve a vonal:
    if (aktVonal != null && aktVonal.npoints > 0) {
      // Adatmdosts:
      aktVonal.addPoint(e.getX(),e.getY());
      // Utols vonalszakasz kirajzolsa:
      Graphics gr = getGraphics();
      gr.setColor(aktSzin);
      gr.drawLine(aktVonal.xpoints[aktVonal.npoints-2],
        aktVonal.ypoints[aktVonal.npoints-2],
        aktVonal.xpoints[aktVonal.npoints-1],
        aktVonal.ypoints[aktVonal.npoints-1]);
      gr.dispose();
    }
  }

  public void mouseMoved(MouseEvent e) {
  }
}

public class Rajzolas extends JFrame implements ActionListener {
  JButton btTorol, btRajzoloSzin;
  Rajzlap rajzlap;
  Color[] colors = {Color.BLACK,Color.WHITE,Color.RED,
    Color.PINK,Color.ORANGE,Color.MAGENTA,Color.BLUE};
  int rajzoloSzin = 0;

  public Rajzolas() {
    setSize(500,400);
    setDefaultCloseOperation(EXIT_ON_CLOSE);
    // Trls s sznllts gombok:
    JPanel pn = new JPanel();
    pn.add(btTorol = new JButton("Trl"));
    pn.add(new JLabel("Rajzolszn",JLabel.RIGHT));
    pn.add(btRajzoloSzin = new JButton(""));
    btRajzoloSzin.setBackground(colors[rajzoloSzin]);

    getContentPane().add(pn,"North");

    // Rajzolterlet:
    getContentPane().add(rajzlap = new Rajzlap(),"Center");
    rajzlap.setBackground(Color.LIGHT_GRAY);
    rajzlap.setColor(colors[rajzoloSzin]);

    btRajzoloSzin.addActionListener(this);
    btTorol.addActionListener(this);
    show();
  }

  public void actionPerformed(ActionEvent e) {
    if (e.getSource() == btTorol)
      rajzlap.clear();
    else if (e.getSource() == btRajzoloSzin) {
      if (rajzoloSzin < colors.length-1)
        rajzoloSzin++;
      else
        rajzoloSzin = 0;
      btRajzoloSzin.setBackground(colors[rajzoloSzin]);
      rajzlap.setColor(colors[rajzoloSzin]);
    }
  }

  public static void main (String args[]) {
    new Rajzolas();
  } // main
} // Rajzolas
