/*
 * Mintaprogramok/13. fejezet
 * RenDel.java
 *
 * Angster Erzsbet: OO tervezs s programozs, Java II. ktet
 * 2002.09.01.
 */

import java.io.*;

public class RenDel {
  // A megadott knyvtr listzsa:
  static void printDir(String dir) {
    File f = new File(dir);
    if (!f.exists() || f.isFile()) {
      System.out.println(dir+" nem egy knyvtr.");
      return;
    }
    System.out.println(dir+" bejegyzsei:");
    String[] list = f.list();
    // A knyvtr bejegyzseinek kirsa:
    for (int i=0; i<list.length; i++)
      System.out.println(list[i]);
    System.out.println();
  }

  public static void main (String args[]) {
    String dir = "c:/javaprog/work/proba";
    printDir(dir);

    // dir-ben az App.java file tnevezse App.~jav -ra:
    File f = new File(dir,"App.java");
    if (f.renameTo(new File(dir,"App.~jav")))
      System.out.println("Az tnevezs sikerlt.");
    else
      System.out.println("Az tnevezs nem sikerlt.");
    printDir(dir);

    // Az icons knyvtr trlse, eltte rtse:
    f = new File(dir,"icons");
    File[] list = f.listFiles();
    if (list!=null) {
      for (int i=0; i<list.length; i++)
        list[i].delete();
      if (f.delete())
        System.out.println("A trls sikerlt.");
      else
        System.out.println("A trls nem sikerlt.");
      printDir(dir);
    }
    else
      System.out.println("Nincs ilyen knyvtr.");

    // A readme.txt ltrehozsa:
    f = new File(dir,"readme.txt");
    try {
      f.createNewFile();
      System.out.println("A ltrehozs sikerlt.");
    }
    catch(IOException e) {
      System.out.println("A ltrehozs nem sikerlt.");
    }
    printDir(dir);
  } // main
} // RenDel
