/*
 * Mintaprogramok/14. fejezet
 * ObjStreamDemo.java
 *
 * Angster Erzsbet: OO tervezs s programozs, Java II. ktet
 * 2002.09.01.
 */

import java.io.*;

class MyClass implements Serializable {
  int n=67;

  public String toString() {
    return Integer.toString(n);
  }
}

public class ObjStreamDemo {
  static void letrehoz() {
    try {
      ObjectOutputStream out = new ObjectOutputStream(
           new FileOutputStream("work/objektumok.dat"));   //1
      // Az objektumfolyamra objektumot s primitv adatot is runk:
      out.writeObject(new String("Rold Roland"));
      out.writeObject(new String("Telivr Olivr"));
      out.writeInt(54321);  // primitv adat
      out.writeObject(new MyClass());
      out.close();
    }
    catch (FileNotFoundException ex) {
      System.out.println("Az llomnyt nem lehet ltrehozni!");
    }
    catch (IOException ex) {
      System.out.println("I/O hiba! "+ex);
    }
  }

  static void listaz() {
    try {
      ObjectOutput o;
      ObjectInputStream in = new ObjectInputStream(
           new FileInputStream("work/objektumok.dat"));
      // A visszaolvass a felrsi sorrendben trtnik:
      String s1 = (String)in.readObject();                 //2
      String s2 = (String)in.readObject();
      int i = in.readInt();
      MyClass obj = (MyClass)in.readObject();
      in.close();
      System.out.println(s1+" "+s2+" "+i+" "+obj);
    }
    catch (FileNotFoundException ex) {
      System.out.println("Nincs ilyen llomny!");
    }
    catch (ClassNotFoundException ex) {
      System.out.println("Rossz osztly!");
    }
    catch (IOException ex) {
      System.out.println("I/O hiba! "+ex);
    }
  }

  public static void main(String[] args) {
    letrehoz();
    listaz();
  }
}
