/*
 * Mintaprogramok/14. fejezet
 * ObjStreamDemo2.java
 *
 * Angster Erzsbet: OO tervezs s programozs, Java II. ktet
 * 2002.09.01.
 */

import java.io.*;

class MyClass implements Serializable {
  int n=67;

  public String toString() {
    return Integer.toString(n);
  }
}

public class ObjStreamDemo2 {
  static void letrehoz() {
    try {
      // Az objektumfolyamot tovbbrsra nyitjuk meg (append==true):
      ObjectOutputStream out = new ObjectOutputStream(
           new FileOutputStream("work/objektumok2.dat"));
      // Csak objektumot runk ki (primitv adatot nem):
      out.writeObject(new String("Rold Roland"));
      out.writeObject(new String("Telivr Olivr"));
      out.writeObject(new Integer(54321));
      out.writeObject(new MyClass());
      out.close();
    }
    catch (FileNotFoundException ex) {
      System.out.println("A fjlt nem lehet ltrehozni!");
    }
    catch (IOException ex) {
      System.out.println("I/O hiba a ltrehozskor! "+ex);
    }
  }

  static void listaz() {
    try {
      ObjectInputStream in = new ObjectInputStream(
           new FileInputStream("work/objektumok2.dat"));
      try {
        while (true)
          System.out.println(in.readObject());
      }
      catch (IOException ex) {
        in.close(); // llomny vge
      }
    }
    catch (FileNotFoundException ex) {
      System.out.println("Nincs ilyen fjl!");
    }
    catch (ClassNotFoundException ex) {
      System.out.println("Rossz osztly!");
    }
    catch (IOException ex) {
      System.out.println("I/O hiba olvasskor! "+ex);
    }
  }

  public static void main(String[] args) {
    letrehoz();
    listaz();
  }
}
