/*
 * Mintaprogramok/14. fejezet
 * SajatSzerializacio.java (a tanknyvben nem szerepel)
 *
 * Angster Erzsbet: OO tervezs s programozs, Java II. ktet
 * 2002.09.01.
 *
 * Vektor szerializcija sajt algoritmus szerint.
 * A vektorhoz most egy fej is tartozik, ami kirsra kerl.
 */

import java.io.*;
import java.util.Vector;

class CustomVector extends Vector implements Serializable {
  private String fej = "Vektor: ";

  // Az objektum kirsa (szerializlsa) sajt algoritmus szerint:
  private void writeObject(ObjectOutputStream out)  throws IOException, ClassNotFoundException {
    out.writeObject(fej);
    // Alaprtelmezett kirs (szerializls):
    out.defaultWriteObject();
  }
  // Az objektum beolvassa sajt algoritmus szerint:
  private void readObject(ObjectInputStream in) throws IOException, ClassNotFoundException {
    fej = (String)in.readObject();
    // Alaprtelmezett beolvass:
    in.defaultReadObject();
  }
  public String toString() {
    return fej + super.toString();
  }
}

public class SajatSzerializacio {
  public static void main(String[] args) {
    try {
      CustomVector cv = new CustomVector();
      cv.add("Egy");
      cv.add(new Integer(2));
      cv.add("Hrom");

      ObjectOutputStream out = new ObjectOutputStream(new FileOutputStream("work/CustomVector.dat"));
      out.writeObject(cv);
      out.close();
    }
    catch (IOException ex) {
    }

    try {
      ObjectInputStream in = new ObjectInputStream(new FileInputStream("work/CustomVector.dat"));
      CustomVector cv = (CustomVector)in.readObject();
      System.out.println(cv);
      in.close();
    }
    catch (IOException ex) {
    }
    catch (ClassNotFoundException ex) {
    }
  }
}
