/*
 * Mintaprogramok/19. fejezet
 * CloneMely.java
 *
 * Angster Erzsbet: OO tervezs s programozs, Java II. ktet
 * 2002.09.01.
 *
 * Feladat - Dik objektum klnozsa
 *
 * Ksztsnk egy Ember osztlyt, melyben egy ember nevt s
 * szletsi vt troljuk! Szrmaztassunk ebbl egy Dik
 * osztlyt, mely tartalmaz egy jegyeket trol tmbt is.
 * Klnozzuk a megadott osztlyok objekumait gy, hogy a
 * msolt objektumok fggetlenek legyenek az eredetitl,
 * vagyis klnozzuk a jegyeket is!
 */

class Ember implements Cloneable {                         //1
  private String nev;
  private int szulEv;

  public Ember(String nev, int szulEv) {
    this.nev = nev;
    this.szulEv = szulEv;
  }

  public Object clone() {                                  //2
    try {
      return super.clone();
    }
    catch (CloneNotSupportedException e) {
      // Nem fordulhat el, hisz az objektum klnozhat:
      return this;
    }
  }

  public String toString() {
    return nev + " " + szulEv;
  }
}

class Diak extends Ember {                                 //3
  private int[] jegyek;
  private int jegyekSzama = 3;

  public Diak(String nev, int szulEv) {
    super(nev,szulEv);
    // A diknak alaprtelmezsben 3 db 4-ese van:
    jegyek = new int[jegyekSzama];
    for (int i=0; i<jegyekSzama; i++)
      jegyek[i] = 4;
  }

  public void setJegy(int index, int jegy) {
    jegyek[index] = jegy;
  }

  public String toString() {
    String str = super.toString();
    for (int i=0; i<jegyekSzama; i++)
      str = str + " " + jegyek[i];
    return str;
  }

  public Object clone() {                                  //4
    Diak diak = (Diak)super.clone();
    diak.jegyek = (int[])jegyek.clone();
    return diak;
  }
}

public class CloneMely {
  public static void main (String args[]) {
    Diak diak1 = new Diak("Karinthy Frigyes",1887);
    Diak diak2 = (Diak)diak1.clone();                      //5
    diak1.setJegy(2,5);                                    //6
    System.out.println(diak1);
    System.out.println(diak2);
  }
}

/*
A program futsa
Karinthy Frigyes 1887 4 4 5
Karinthy Frigyes 1887 4 4 4

A program elemzse
Az Ember osztly //1-ben implementlja a Cloneable jell
interfszt. A clone() metdus (//2) az sben megadott klnozst
hvja meg; a metdus visszatrsi rtke a msolt objektum lesz.
A klnozs a try gban trtnik. A catch gra nem kerlhet a
vezrls, hiszen objektumunk klnozhat; a szintaktika itt
megkvnja a visszaadsi rtk megadst, ezrt visszaadjuk
az eredeti objektumot.

A Dik osztlyban (//3) a Cloneable interfszt mr nem kell
implementlnunk, hiszen azt az s osztlyban mr megtettk,
s az implementls rkldik (ha mgis implementlnnk, az
nem okozna szintaktikai hibt). Mivel mly klnozst szeretnnk
vgrehajtani (a jegyek tmbt is klnozzuk), //4-ben t kell
rnunk a clone() metdust. A CloneNotSupported Exception
kivtellel nem kell foglalkoznunk, azt az s clone()-ban mr
lekezeltk. Elszr elksztjk az objektum sekly msolatt
az s clone() meghvsval. Az gy kapott diak objektumra
rknyszertjk sajt osztlyt (//5). Itt azonban a bjtrl
bjtra val msols kvetkeztben a jegyek tmb mutatja mg
az eredeti tmbre mutat, ezrt a tmbt is klnozzuk (//6) -
gy az objektumnak sajt, diszjunkt tmbje lesz. A metdus
visszatrsi rtke az gy kiegsztett objektum lesz.

A main metdusban ltrehozunk egy diak1 objektumot, melyrl
//7-ben egy msolatot ksztnk diak2 azonostval.
//8-ban a diak1 2. index jegyt trjuk 5-re. A program
futsbl ltszik, hogy csak diak1-nek vltozott meg a jegye.
Ha csak sekly klnozst alkalmaztunk volna, - azaz nem adtuk
volna meg //4-ben a clone() metdust vagy elhagytuk volna abbl
a //6-os sort, - akkor a //8-as utasts hatsra mindkt
diknak megvltozott volna a jegye.
*/
