/*
 * Mintaprogramok/19. fejezet
 * RendszerJellemzok.java
 *
 * Angster Erzsbet: OO tervezs s programozs, Java II. ktet
 * 2002.09.01.
 */

import java.util.*;

public class RendszerJellemzok {
  public static void main(String[] args) {
    System.out.print("Java home konyvtr: ");
    System.out.println(System.getProperty("java.home"));

    System.out.print("Hasznl: ");
    System.out.println(System.getProperty("user.name"));

    System.out.print("Osztlytvonal: ");
    System.out.println(System.getProperty("java.class.path"));

    System.out.println("\nAz sszes rendszerjellemz:");
    Properties prop = System.getProperties();
    StringTokenizer st = new StringTokenizer(prop.toString(),",");
    while (st.hasMoreTokens()) {
      System.out.println(st.nextToken());
    }


    // Rendszerjellemzk csoportostva:

    // A JRE verzija, szlltja, URL cme, home knyvtra:
    System.out.println("-------------JRE adatai:");
    System.out.println(System.getProperty("java.version"));
    System.out.println(System.getProperty("java.vendor"));
    System.out.println(System.getProperty("java.vendor.url"));
    System.out.println(System.getProperty("java.home"));

    // A Java VM adatai:
    System.out.println("\n-------------Java VM adatai:");
    // 6 db

    // A Java specifikci adatai:
    System.out.println("\n-------------Java specifikci adatai:");
    // 3 db

    // java.ext.dirs?
    System.out.println("\n-------------java.ext.dirs:");
    System.out.println(System.getProperty("java.ext.dirs"));

    // A class formtum verzija s a classpath:
    System.out.println("\n-------------A class formtum verzija s a classpath: *****");
    System.out.println(System.getProperty("java.class.version"));
    System.out.println(System.getProperty("java.class.path"));

    // Szepartorok:
    System.out.println("\n-------------Szepartorok:");
    System.out.println(System.getProperty("file.separator"));
    System.out.println(System.getProperty("path.separator"));
    System.out.println(System.getProperty("line.separator"));

    // Az opercis rendszer neve, architektrja s verzija:
    System.out.println("\n-------------Opercis rendszer adatai:");
    System.out.println(System.getProperty("os.name"));
    System.out.println(System.getProperty("os.arch"));
    System.out.println(System.getProperty("os.version"));

    // A felhasznl neve, home knyvtra s az aktulis knyvtr:
    System.out.println("\n-------------Felhasznli adatok:");
    System.out.println(System.getProperty("user.name"));
    System.out.println(System.getProperty("user.home"));
    System.out.println(System.getProperty("user.dir"));

  }
}
