/*
 * Mintaprogramok/21. fejezet
 * TreeMapUser.java
 *
 * Angster Erzsbet: OO tervezs s programozs, Java II. ktet
 * 2004.08.01.
 */

import java.util.*;
import java.text.DateFormat;

class User {                                               //1
  private String userName;   // felhasznlnv
  private String password;   // jelsz
  private Date lastVisited;  // a legutbbi belps idpontja

  public User(String userName, String password) {
    this.userName = userName;
    this.password = password;
    this.lastVisited = new Date(); // mai dtum
  }
  public User(String userName) {
    this(userName,"");
  }
  public String getUserName() { return userName; }
  public String getPassword() { return password; }
  public String getLastVisited() {
    return DateFormat.getDateTimeInstance().
        format(lastVisited);
  }
  public void setLastVisited() {
    lastVisited = new Date();
  }
  public String toString() {
    return userName+", "+password+", "+getLastVisited();
  }
}

public class TreeMapUser {
  public static void main(String[] args) {
    TreeMap users = new TreeMap();                         //2

    users.put("Nagybuta", new User("NagyButa", "netuddmeg"));
    users.put("Bendegz", new User("Bendegz", "anyukd"));
    users.put("Erzsbet", new User("Erzsbet", "kimst"));
    users.put("Naspolya", new User("Naspolya", "eddmeg"));

    System.out.println("Felhasznlk szma: " +
                       users.size());                      //3
    // Felhasznlnevek listzsa:
    System.out.println("\nFelhasznlnevek:");             //4
    Iterator iter = users.keySet().iterator();
    while (iter.hasNext())
      System.out.println(iter.next());

    // Felhasznlk adatai:
    System.out.println("\nFelhasznlk adatai:");          //5
    Collection values = users.values();
    iter = values.iterator();
    while (iter.hasNext())
      System.out.println(iter.next());

    // Megadott felhasznl jelszavnak kirsa:
    String userName = "Bendegz";                          //6
    User user = (User)users.get(userName);
    if (user == null)
      System.out.println("\nNincs " + userName);
    else {
      System.out.println("\n" + userName +
        " jelszava: " + user.getPassword() +
        ", legutbbi ltogatsa: " + user.getLastVisited());
    }
  }
}
