/*
 * Mintaprogramok/Feladatok
 * Projekt: Cimjegyzek
 * Csomag: gui
 * SzemelyDialog.java
 *
 * Angster Erzsbet: OO tervezs s programozs, Java II. ktet
 * 2002.09.01.
 */

package gui;
import db.Szemely;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

// Dialgus a Szemely objektum sszelltsra:
public class SzemelyDialog extends JDialog implements ActionListener, KeyListener {
  private Container cp = getContentPane();
  private JTextField tfId, tfNev, tfIrszam, tfVaros, tfCim, tfTelefon;
  private JButton btOk, btMegse;
  private boolean ok;

  public SzemelyDialog(JFrame parent) {
    super(parent,"Szemly tulajdonsgai",true);
    setLocation(getParent().getX()+50,getParent().getY()+50);
    setResizable(false);
    cp.setLayout(new GridLayout(0,1));

    // Nv:
    JPanel pn = new JPanel();
    pn.add(new Label("Nv: "));
    pn.add(tfNev = new JTextField(Szemely.NEV_MERET+1));
    cp.add(pn);

    // Irnytszm:
    pn = new JPanel();
    pn.add(new Label("Irnytszm: "));
    pn.add(tfIrszam = new JTextField(Szemely.IRSZAM_MERET+1));
    cp.add(pn);

    // Vros:
    pn = new JPanel();
    pn.add(new Label("Vros: "));
    pn.add(tfVaros = new JTextField(Szemely.VAROS_MERET+1));
    cp.add(pn);

    // Cm:
    pn = new JPanel();
    pn.add(new Label("Cm: "));
    pn.add(tfCim = new JTextField(Szemely.CIM_MERET+1));
    cp.add(pn);

    // Telefon:
    pn = new JPanel();
    pn.add(new Label("Telefon: "));
    pn.add(tfTelefon = new JTextField(Szemely.TELEFON_MERET+1));
    cp.add(pn);

    // Ok: adatok elmentse; Mgse: adatok elvetse
    JPanel pnButtons = new JPanel();
    pnButtons.add(btOk = new JButton("Ok"));
    pnButtons.add(btMegse = new JButton("Mgse"));
    cp.add(pnButtons);

    btOk.addActionListener(this);
    btMegse.addActionListener(this);
    tfNev.addKeyListener(this);
    tfIrszam.addKeyListener(this);
    tfVaros.addKeyListener(this);
    tfCim.addKeyListener(this);
    tfTelefon.addKeyListener(this);
    pack();
  }

  /* Megjelenik a dialgus. Ha az OK lenyomsval csukjk be, akkor
     a paramterben megadott szemely objektum a bert adatokat fogja tartalmazni.
   */
  public boolean showDialog(Szemely szemely) {
    setSzemely(szemely);
    ok = false;
    tfNev.requestFocus();
    show();
    if (ok)
      getSzemely(szemely);
    return ok;
  }

  // Az objektum adatainak sztosztsa az ablak mezibe:
  private void setSzemely(Szemely szemely) {
    tfNev.setText(szemely.nev);
    tfIrszam.setText(szemely.irszam);
    tfVaros.setText(szemely.varos);
    tfCim.setText(szemely.cim);
    tfTelefon.setText(szemely.telefon);
  }

  // Az objektum adatainak sszelltsa az ablak mezibl:
  private void getSzemely(Szemely szemely) {
    szemely.nev = tfNev.getText().trim();
    szemely.irszam = tfIrszam.getText().trim();
    szemely.varos = tfVaros.getText().trim();
    szemely.cim = tfCim.getText().trim();
    szemely.telefon = tfTelefon.getText().trim();
  }

  public void actionPerformed(ActionEvent e) {
    if (e.getSource() == btOk) {
      ok = true;
      setVisible(false);
    }
    else if (e.getSource() == btMegse) {
      ok = false;
      setVisible(false);
    }
  }

  public void keyTyped(KeyEvent e) {
  }

  // ENTER-re s ESC-re kilp a dialgusbl:
  public void keyPressed(KeyEvent e) {
    if (e.getKeyCode()==KeyEvent.VK_ENTER) {
      ok = true;
      setVisible(false);
    }
    else if (e.getKeyCode()==KeyEvent.VK_ESCAPE) {
      ok = false;
      setVisible(false);
    }
  }

  public void keyReleased(KeyEvent e) {
  }
}
