/*
 * Mintaprogramok/Feladatok
 * Projekt: Temak
 * Temak.java
 *
 * Angster Erzsbet: OO tervezs s programozs, Java II. ktet
 * 2005.01.10.
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import extra.hu.*;

public class Temak extends JFrame implements ActionListener, ListSelectionListener {
  Container cp = getContentPane();
  DefaultListModel mdTemak = new DefaultListModel(); // lista modellje
  JList lstTemak; // a lista
  JButton btKilep, btUj, btTorol, btFel, btLe; // gombok

  public Temak() {
    setDefaultCloseOperation(EXIT_ON_CLOSE);
    setLocation(100,100);
    setTitle("Tmk");

    lstTemak = new JList(mdTemak); // lista a tartalompanelre
    cp.add(new JScrollPane(lstTemak));  // lehet grgetni
    lstTemak.setSelectionMode(   // csak egyet lehet kivlasztani
        ListSelectionModel.SINGLE_SELECTION);

    JPanel pnGombok = new JPanel(); // gombok felpakolsa
    pnGombok.setLayout(new GridLayout(0,1));
    pnGombok.add(btUj = new JButton("j"));
    pnGombok.add(btTorol = new JButton("Trl"));
    pnGombok.add(new JLabel(" "));
    pnGombok.add(btFel = new JButton("Fel"));
    pnGombok.add(btLe = new JButton("Le"));
    pnGombok.add(new JLabel(" "));
    pnGombok.add(btKilep = new JButton("Kilp"));
    cp.add(pnGombok,"East");

    btUj.addActionListener(this);   // figyelk felfzse
    btTorol.addActionListener(this);
    btFel.addActionListener(this);
    btLe.addActionListener(this);
    btKilep.addActionListener(this);
    lstTemak.addListSelectionListener(this);
    enableUpdate();
    pack();
    show();
  }
  /** Engedlyezsek belltsa */
  void enableUpdate() {
    int n = lstTemak.getSelectedIndex();
    btFel.setEnabled(n>0); // ha fent van, nem mehet feljebb
    btLe.setEnabled(n<mdTemak.getSize()-1); // ha lent van, nem mehet lejjebb
    btTorol.setEnabled(n>=0); //trls eng., ha van kijells
  }
  // Ha mozogtak a listban, jrartkeljk az engedlyezseket:
  public void valueChanged(ListSelectionEvent e) {
    enableUpdate();
  }
  // A hasznlati eset indtsa:
  public void actionPerformed(ActionEvent e) {
    // j tma:
    if (e.getSource()==btUj) {
      String tema = HuOptionPane.showInputDialog(this,"j tma");
      if (tema != null) // ha betttek valamit, bevisszk
        mdTemak.addElement(tema);
      lstTemak.setSelectedValue(tema,true); // elem kivlasztsa
    }
    // Kivlasztott tma trlse:
    else if (e.getSource()==btTorol) {
      int poz = lstTemak.getSelectedIndex(); // kiv. elem indexe
      if (poz==-1)  // res a lista
        return;
      mdTemak.remove(poz); // poz. tma trlse
      if (mdTemak.getSize() != 0) { // ha van mg tma
        if (poz == mdTemak.getSize()) // ha utols volt
          poz--;
        lstTemak.setSelectedIndex(poz); // elem kijellse
      }
    }

    // Tma mozgatsa eggyel feljebb:
    else if (e.getSource()==btFel) {
      int poz = lstTemak.getSelectedIndex();
      if (poz > 0) {
        mdTemak.add(poz-1,mdTemak.remove(poz));
        lstTemak.setSelectedIndex(poz-1);
      }
    }
    // Tma mozgatsa eggyel lejjebb:
    else if (e.getSource()==btLe) {
      int poz = lstTemak.getSelectedIndex();
      if (poz < mdTemak.getSize()-1) {
        mdTemak.add(poz+1,mdTemak.remove(poz));
        lstTemak.setSelectedIndex(poz+1);
      }
    }
    // Kilps:
    else if (e.getSource()==btKilep)
      System.exit(0);
  }

  public static void main(String[] args) {
    new Temak();
  }
}
